OGRE: Ogre::StaticGeometry::MaterialBucket Class Reference - OGRE Documentation

# Ogre::StaticGeometry::MaterialBucket Class Reference

A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly the same LOD). More...

`#include <OgreStaticGeometry.h>`

Inheritance diagram for Ogre::StaticGeometry::MaterialBucket:

[legend]

List of all members.

## Public Types
typedef std::vector < GeometryBucket * > | GeometryBucketList
| list of Geometry Buckets in this region
typedef VectorIterator < GeometryBucketList > | GeometryIterator
| Iterator over geometry.
## Public Member Functions
| MaterialBucket (LODBucket *parent, const String &materialName)
virtual | ~MaterialBucket ()
LODBucket * | getParent (void)
const String & | getMaterialName (void) const
| Get the material name.
void | assign (QueuedGeometry *qsm)
| Assign geometry to this bucket.
void | build (bool stencilShadows)
| Build.
void | addRenderables (RenderQueue *queue, uint8 group, Real camSquaredDist)
| Add children to the render queue.
const MaterialPtr & | getMaterial (void) const
| Get the material for this bucket.
GeometryIterator | getGeometryIterator (void)
| Get an iterator over the contained geometry.
Technique * | getCurrentTechnique (void) const
| Get the current Technique.
void | dump (std::ofstream &of) const
| Dump contents for diagnostics.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Types
typedef std::map< String, GeometryBucket * > | CurrentGeometryMap
## Protected Member Functions
String | getGeometryFormatString (SubMeshLodGeometryLink *geom)
| Get a packed string identifying the geometry format.
## Protected Attributes
LODBucket * | mParent
| Pointer to parent LODBucket.
String | mMaterialName
| Material being used.
MaterialPtr | mMaterial
| Pointer to material being used.
Technique * | mTechnique
| Active technique.
GeometryBucketList | mGeometryBucketList
| list of Geometry Buckets in this region
CurrentGeometryMap | mCurrentGeometryMap

## Detailed Description

A MaterialBucket is a collection of smaller buckets with the same Material (and implicitly the same LOD).

Definition at line 247 of file OgreStaticGeometry.h.

## Member Typedef Documentation

typedef std::vector<GeometryBucket*> Ogre::StaticGeometry::MaterialBucket::GeometryBucketList

list of Geometry Buckets in this region

Definition at line 251 of file OgreStaticGeometry.h.

typedef std::map<String, GeometryBucket*> Ogre::StaticGeometry::MaterialBucket::CurrentGeometryMap`[protected]`

Definition at line 265 of file OgreStaticGeometry.h.

typedef VectorIterator<GeometryBucketList> Ogre::StaticGeometry::MaterialBucket::GeometryIterator

Iterator over geometry.

Definition at line 286 of file OgreStaticGeometry.h.

## Constructor & Destructor Documentation

Ogre::StaticGeometry::MaterialBucket::MaterialBucket | ( | LODBucket * | parent,
|  | const String & | materialName |
| ) |  |  |

virtual Ogre::StaticGeometry::MaterialBucket::~MaterialBucket | ( |  | ) | `[virtual]`

## Member Function Documentation

String Ogre::StaticGeometry::MaterialBucket::getGeometryFormatString | ( | SubMeshLodGeometryLink * | geom | ) | `[protected]`

Get a packed string identifying the geometry format.

LODBucket* Ogre::StaticGeometry::MaterialBucket::getParent | ( | void |  | ) |

Definition at line 273 of file OgreStaticGeometry.h.

const String& Ogre::StaticGeometry::MaterialBucket::getMaterialName | ( | void |  | ) | const

Get the material name.

Definition at line 275 of file OgreStaticGeometry.h.

void Ogre::StaticGeometry::MaterialBucket::assign | ( | QueuedGeometry * | qsm | ) |

Assign geometry to this bucket.

void Ogre::StaticGeometry::MaterialBucket::build | ( | bool | stencilShadows | ) |

Build.

void Ogre::StaticGeometry::MaterialBucket::addRenderables | ( | RenderQueue * | queue,
|  | uint8 | group,
|  | Real | camSquaredDist |
| ) |  |  |

Add children to the render queue.

const MaterialPtr& Ogre::StaticGeometry::MaterialBucket::getMaterial | ( | void |  | ) | const

Get the material for this bucket.

Definition at line 284 of file OgreStaticGeometry.h.

GeometryIterator Ogre::StaticGeometry::MaterialBucket::getGeometryIterator | ( | void |  | ) |

Get an iterator over the contained geometry.

Technique* Ogre::StaticGeometry::MaterialBucket::getCurrentTechnique | ( | void |  | ) | const

Get the current Technique.

Definition at line 290 of file OgreStaticGeometry.h.

void Ogre::StaticGeometry::MaterialBucket::dump | ( | std::ofstream & | of | ) | const

Dump contents for diagnostics.

void Ogre::StaticGeometry::MaterialBucket::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables |
| ) |  |  |

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

LODBucket* Ogre::StaticGeometry::MaterialBucket::mParent`[protected]`

Pointer to parent LODBucket.

Definition at line 254 of file OgreStaticGeometry.h.

String Ogre::StaticGeometry::MaterialBucket::mMaterialName`[protected]`

Material being used.

Definition at line 256 of file OgreStaticGeometry.h.

MaterialPtr Ogre::StaticGeometry::MaterialBucket::mMaterial`[protected]`

Pointer to material being used.

Definition at line 258 of file OgreStaticGeometry.h.

Technique* Ogre::StaticGeometry::MaterialBucket::mTechnique`[protected]`

Active technique.

Definition at line 260 of file OgreStaticGeometry.h.

GeometryBucketList Ogre::StaticGeometry::MaterialBucket::mGeometryBucketList`[protected]`

list of Geometry Buckets in this region

Definition at line 263 of file OgreStaticGeometry.h.

CurrentGeometryMap Ogre::StaticGeometry::MaterialBucket::mCurrentGeometryMap`[protected]`

Definition at line 266 of file OgreStaticGeometry.h.

The documentation for this class was generated from the following file:

- OgreStaticGeometry.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:37:26 2009